:computer: ***Computer Organization and Design***



#### 1.计算机概要与技术

> :biking_man: 摩尔定律：摩尔定律是英特尔创始人之一戈登·摩尔的经验之谈，其核心内容为：当价格不变时，集成电路上可容纳的元器件的数目，约每隔 18-24 个月便会增加一倍，性能也将提升一倍。换言之，每一美元所能买到的电脑性能，将每隔 18-24 个月翻一倍以上。
>
> 摩尔定律在一定程度上律揭示了信息技术进步的速度，但是随着 CPU 技术的逐渐耗尽，在通用芯片 CPU 领域，摩尔定律正在逐渐放缓。



计算机应用主要包括 3 类：

- 个人计算机（Personal Computer，PC）：用于个人使用的计算机，通常包含图形显示器、键盘和鼠标。
- 服务器（server）：用于为多用户圆形大型程序的计算机，通常由多个用户并行使用，并且一般通过网络访问。
- 嵌入式计算机（embedded computer）：嵌入到其他设备的计算机，一般运行预定义的一个或一组应用程序；它是数量最多的一类计算机，包括汽车，电视中的微处理器等。



后 PC 时代：

1. 个人移动设备（智能手机，平板电脑）的兴起。
2. 云计算（cloud computing）代替了传统的服务器，它依赖于被称为仓储规模计算机的巨型数据中心，使用大型服务器集群在网络上提供服务，一些运营商可根据应用需求租借不同数量的服务器。



硬件和软件如何影响程序性能：

| 软件或硬件组成元素         | 该元素如何影响性能                       |
| -------------------------- | ---------------------------------------- |
| 算法                       | 决定了源码级语句的数量和 I/O 操作的数量  |
| 编程语言、编译器和体系结构 | 决定了每条源码级语言对应的计算机指令数量 |
| 处理器和存储系统           | 决定了指令的执行速度                     |
| I/O 系统（硬件和操作系统） | 决定了 I/O 操作可能的执行速度            |



:alarm_clock: 程序概念入门：

​	众所周知，计算机中的硬件只能执行极为简单的低级指令，从复杂的应用程序到简单的极其指令需要经过几个软件层次来讲复杂的高层次操作逐步解释或翻译成为简单的计算机指令（应用软件 -> 系统软件 -> 硬件）。

**系统软件**：系统软件是提供常用服务的软件，包括操作系统、编译程序、加载程序和汇编程序等。

系统软件由很多种，对于现代计算机来说，操作系统和编译程序是必需的：

1. 操作系统：

   1. 处理基本的输入输出操作。
   2. 分配内存和外存。
   3. 为多个应用程序提供共享计算机资源的服务。

   目前我们使用的操作系统主要有 Windows、Linux 和 IOS。

2. 编译程序：将高级语言翻译成硬件能执行的指令。

> 汇编语言：
>
> - 第一代的程序员直接使用二进制与计算机进行通信，这种过程非常乏味，于是他们很快发明了助记符以符合人类的思维方式。
>
> - 助记符最先是由手工翻译成二进制的，随后设计人员开发出了一种称为汇编程序的软件，可以将助记符形式的指令翻译为对应的二进制。
>
>   例如：程序员写下 add A.B，汇编程序会将改符号翻译为 1000110010100000 。
>
> - 类似于 add A.B 这种符号语言被称为汇编语言，直至今天也仍有使用。
>
> 高级编程语言：如 C、C++、Java、Python 等可移植的语言，由一些单词和符号组成，可以由编译器转换为汇编语言（也有一些语言跳过汇编语言直接将高级编程语言翻译为机器语言）；使用高级编程语言的好处有：
>
> 1. 可以使程序员使用更自然的语言来思考。
> 2. 提高了程序员的生产率。
> 3. 提高了程序对于计算机的独立性，编译程序和汇编语言能够将高级编程语言翻译成任何计算机的二进制指令。



:hamster: 硬件概念入门：

组成计算机的 5 个经典部件：输入、输出、存储器、数据通路（运算器）和控制器，其中最后两个部件通常合称为处理器。

处理器从存储器中得到指令和数据，输入部件将数据写入存储器，输出部件从内存中读出数据，控制器向数据通路、存储器、输入和输出部件发出命令信号。

显示器：

1. **液晶显示**（Liquid Crystal Display，LCD）：大多数个人移动设备都使用液晶显示来获得轻巧、低功耗的显示效果。

   > :elephant: 液晶显示原理：
   >
   > 1. 液晶屏幕在通电时，屏幕中的背光板（通常为 LED）会发出白光，通过两个互相垂直的偏振片，此时没有光打到屏幕上，屏幕呈现黑色；
   > 2. 在两个互相垂直的偏振片之间，存在一个液晶分子层，光会受到液晶分子层的影响而改变方向，使得光能通过第二个偏振片打到屏幕上。
   > 3. 在液晶层两边有两个电极层，电极层通电过后，就会对液晶分子产生影响，于是我们能够通过控制电压来控制液晶层的扭曲角度，从而控制屏幕每个像素点的明暗程度。
   > 4. 在每一个像素点中，都被分为了 3 个子像素点，每个子像素点前面都添加了一层滤光膜（3 个像素点分别只能透过红、绿、蓝 3 中颜色的光），在 3 种颜色的光强度一致时，屏幕上出现的光仍然是白色。
   > 5. 在每一个子像素中，都会有一个 TFT 薄膜晶体管，这个晶体管就是每个子像素的亮度调节开关，通过控制每个晶体管的电压强度，从而控制该颜色的光的强度，从而混合成各种各样颜色的光。

2. **有机发光二极管**（OrganicLight-Emitting Diode，OLED）：近年来兴起的一种新的屏幕技术，它没有液晶层和背光板，每一个红绿蓝子像素点通过一个独立的有机发光二极管进行单独控制。

> :japanese_ogre: LCD 和 OLED 的原理和区别：https://www.bilibili.com/video/BV1Wz411B7Tf?t=366

3. **触摸屏**：触摸屏可采用多种方式实现，大多数设备使用电容感应实现，由于人是导体，手指在接触到屏幕时会使屏幕上的电场发生变化，进而导致电容的变化，在由传感器读取位置数据。

集成电路：俗称芯片，集成电路中包含计算机最活跃的部分-处理器（也称中央处理单元，CPU），它能够将数字相加，测试结果，并且向 I/O 设备发出指令；除了处理器外，集成电路中还会有存储器等部件。

1. 处理器（CPU）：包含了数据通路和控制器。

   1. **数据通路**：处理器中执行算术操作的部分。
   2. **控制器**：根据程序的指令指挥数据通路、存储器和 I/O 设备的部分。

2. 存储器：包含了内存和缓存。

   1. **内存**：内存是程序运行时的存储空间，由 **DRAM**（Dynamic Random Access Memory，动态随机访问存储器）芯片组成。

      DRAM 是集成电路形式的存储器，可随机访问任何地址的内存（耗时基本相同）

   2. **缓存**：在处理器的内部使用的是另外一种存储器-缓存，缓存一般由 SRAM（Static Random Access Memory，静态随机访问存储器）芯片组成。

      SRAM 与 DRAM 都是集成电路形式的存储器，SRAM 比 DRAM 更快，但造价更贵。

   > :dango: DRAM 与 SRAM 的区别：
   >
   > ![](../img/20170424054051721.jpg)
   >
   > 1. 图一是 SRAM 的电路结构，它存储一个 Bit 需要花费 6 个晶体管，而图二中的 DRAM 只需要花 1 个电容和 1 个晶体管；缓存追求的是速度，所以选择的是 SRAM，而内存追求容量所以选择能够在相同空间中存放更多内容并且造价相对低廉的 DRAM。
   >
   > 2. SRAM 不需要刷新电路就能够保存数据，所以具有静止存取数据的作用。而 DRAM 则需要不停地刷新电路，否则内部的数据将会消失。因为 DRAM 的数据实际上是存在电容里的，而电容放久了，内部的电荷就会越来越少，对外就形成不了电位的变化。而且当对 DRAM 进行读操作的时候需要将电容与外界形成回路，通过检查是否有电荷流进或流出来判断该 Bit 是 1 还是 0。所以无论怎样，在读操作中我们都破坏了原来的数据。所以在读操作结束后需要将数据写回 DRAM 中。而且在整个读或者写操作的周期中，计算机都会进行 DRAM 的刷新，通常是刷新的周期是 4-64ms。
   > 3. SRAM 和 DRAM 的寻址方式不同；内存是以一个二维数组的形式排列的，每个单元都有其行地址和列地址，对于 SRAM 我们可以将行地址和列地址一次性传入到 SRAM 中进行寻址，而对于容量很大的 DRAM 来说，则需要很多根地址线，所以 DRAM 会传送行地址到 DRAM 中先选中一整行，然后将整行数据存到一个锁存器中，等待列地址的传送然后选中所需要的数据，这也是 SRAM 比 DRAM 快的原因之一。



计算机指令集体系结构（Instruction Set Architecture, **ISA**）：包含了程序员正确编写的二进制机器语言程序的齐全部信息，如指令、寄存器、存储访问和I/O 等，是硬件和底层软件之间（操作系统）的接口。

应用程序二进制接口（Application Binary Interface，**ABI**）：包括了用户的部分指令加上程序员调用的操作系统接口，是应用软件和操作系统之间（底层软件）之间的接口。



:artificial_satellite: 数据安全：

前面所说的 DRAM 和 SRAM 都是在通电的情况下保存数据，一旦关掉电源，所有的数据就丢失了，这种称为易失性存储器，也称为主存储器；此外还有一种非易失性存储器，也称为二级存储器。

1. 磁盘：也叫硬盘，是旋转的机械设备，是使用磁介质材料的非易失性二级存储器。

2. 闪存：一种非易失性半导体材料存储器，其价格和速度均低于 DRAM，但是高于磁盘。

   > :basketball_woman: 我们常说的机械硬盘和固态硬盘就是这里的磁盘和闪存。



处理器和存储器制造技术：

**晶体管**：一种受电流控制的开关，集成电路是由成千上万个晶体管组成的芯片，目前集成电路上所容纳的晶体管数量已经达到了亿级，被称为**超大规模集成电路**。

**硅**（Silicon）：硅是沙子中的一种物质，因其导电能力不强，也被称作**半导体**（Semiconductor）。

> :christmas_tree: 使用硅制作的晶体管在进行低压通电时会从绝缘体变成导体，类似于开关，所以被广泛用来制造芯片。



:yum: 性能：性能的定义有很多种，一般来说，个人计算机关注响应时间，而数据中心关注的是吞吐率。

1. 响应时间：也叫执行时间，包括硬盘访问、内存访问、I/O 活动、操作系统开销和 CPU 执行时间等。

2. 吞吐率：性能的另一种度量参数，表示单位时间内完成的任务数量。

   我们可以通过更换更好的处理器等方式增加减少计算机内核的响应时间；可以通过增加多个处理器来提高系统的吞吐量。

   一般来说，降低响应时间都可以增加吞吐量。

3. CPU 执行时间：只表示在 CPU 上所花费的时间。

> CPU 时钟周期：几乎所有计算机都是用时钟来驱动硬件中发生的各种事件，时钟周期是计算机中最基本的、最小的时间单位。一般来说，在一个时钟周期内，CPU 只完成一个最基本的动作（在一些超标量处理器中，由于有多个执行单元，所以在一个时钟周期可以发射多条指令，同样，多条指令可以在一个时钟周期内并行执行结束）。
>
> CPU 时钟频率：CPU 时钟周期的倒数（以秒为单位），如某计算机的时钟周期为 250ps，则它的时钟频率为 4GHz（右键「我的电脑」属性即可查看）。
>
> **CPI**（Clock cycle Per Instruction）：执行每条指令所需的时钟周期数的平均值（CPI 会随着指令组合的不同而变化，如果算法中包含更多的除法运算，CPI 会增大）。
>
> :duck: 对于固定的程序，每台计算机执行的总指令数都是相同的，由此得出一个程序的 CPU 执行时间公式：
> $$
> CPU 执行时间 = 程序指令数 × CPI × 计算机时钟周期时间
> $$
> 或：
> $$
> CPU 执行时间 = 程序指令数 × CPI ÷ 时钟频率
> $$
> 由此，我们将性能分解为了这 3 个关键因素的组合结果。

 

:gear: 功耗：功率的损耗，指设备、器件等输入功率和输出功率的差额，在电路中通常指元器件上耗散的热能。一般来说，计算机的功耗就是计算机能够冷却的极限（假设全部功耗都以热能的形式散发出来）。

1. 动态能耗：晶体管开关过程中产生的能耗，动态能耗与晶体管的负载电容和工作电压有如下关系：
   $$
   功耗∝(1/2)×负载电容×电压^2×开关频率
   $$
   其中，开关频率是时钟频率的函数。近 20 年来，时钟频率增长了 1000 倍，但工作电压从 5V 降到了 1V，所有功耗值增长了 30 倍左右。

   > 目前晶体管的工作电压已经达到极限，如果继续下降会导致晶体管泄漏电流过大，就像水龙头不能完全关闭一样。

2. 静态能耗：晶体管在关闭情况下还是有泄漏电流的情况出现（目前 40% 的能耗来自电流泄露）。



从单处理器到多处理器：20 世纪 80 年代中期依赖处理前期性能的发展图

![](../img/8fd0bce031f542c4996cfbd6e2b1bc8e.png)

从 2002 年开始，受到功耗、指令级并行程度、存储器长延迟时间等的限制，单核处理器的性能增长放缓；在 2006 年，所有桌面和服务器公司都在单片微处理器中加入了多个处理器以求更大的吞吐率，也就是我们现在所熟知的多核处理器。

> :m: 面对多核处理器，程序员必须重新设计代码，以便在这种多核处理器上获得显著的性能提升。



---

#### 2.指令：计算机的语言

计算机语言中的基本单词称为指令，一台计算机的全部指令称为该计算机的指令集。

注：本节中以 MIPS 指令集为例（汇编语言描述）。



MIPS 操作数：

| 名称                    | 示例                                                         | 注释                                                         |
| ----------------------- | ------------------------------------------------------------ | ------------------------------------------------------------ |
| 32 个寄存器             | $s0-$s7、$t0-$t9、$zero、$a0-$a3、$v0-$v1、$k0-$k1、$gp、$fp、$sp、$ra、$at | 寄存器用于数据的快速存取，在 MIPS 中只能对存放在寄存器中的数据进行算术运算。寄存器 $zero 中的值恒为 0；寄存器 $at 被汇编器保留，用于处理大的常数。 |
| 2<sup>30</sup> 个存储字 | Memory[0]、Memory[4]...Memory[4294967288]、Memory[4294967292] | 存储器只能通过数据传输指令访问，MIPS 使用字节编址，所以连续的字地址相差 4，存储器用于保存数据结构、数组和溢出的寄存器。 |

1. 寄存器：寄存器类似于高级语言中的变量，不同的是寄存器的数量有限；

   > :dagger: 大量的寄存器会使时钟周期变长，32 个是设计者在时钟周期和更多的寄存器两个选择中权衡的结果。

2. 存储器：一个下标很大的从 0 开始的一维数组，数据结构（如数组和结构）都是存放在存储器中的。

> MIPS 体系结构中寄存器的大小是 32 位，由于 32 位为一组的情况经常出现，所有将其称为字（word），字是计算机当中的基本访问单位。



例：将 f = (g + h) - (i + 4); 编译为 MIPS 语句：

~~~assembly
add $t0,$s1,$s2
addi $t1,$s3,4
sub $s0,$t0,$t1
~~~

注：$t0-$t7 为临时寄存器，子程序可以使用它们而不用保留，addi 指令可以直接与常数进行加法。



存储器操作数：处理器只能将少量数据保存在寄存器当中，但存储器有数十亿的数据元素，因此 MIPS 必须包含在存储器和寄存器之间传送数据的指令，即数据传输指令（data transfer instruction），通过存储器地址（下标）访问存储器当中的数据。

- lw（load word）：取数指令。
- sw（store word）：存数指令。

例如：当需要对数组进行操作时，一般讲数组的起始地址（基址）存放到寄存器中，然后通过 lw 指定进行读取数组中的元素。

> 假设数组的基址存放在寄存器 $s3 中，读取数组中的下标为 8 的数据的指令为：
>
> lw $t0,32($s3)
>
> 将 $t0 存放到数组中下标为 10 的位置：
>
> sw $t0,40($s3)
>
> 注：MIPS 存储器中连续的字地址相差 4，在通过数组下标获取正确的存储器地址时必须乘以 4。



二进制补码：计算机中使用二进制数的最高位表示正负（0 为正，1 为负），一个二进制的补码就是符号位不变，其余位取反后 +1。

例如在 8 位的存储中，-10 的二进制表示为 10001010，计算机存储其补码 11110101，20 的二进制数表示为 00010100，计算机存储器本身。

那么，当计算机需要计算 20 + (-10) 时，只需计算补码：00010100 + 11110101 得到结果 100001010，因为结果超出了 8 位舍去最高位得到 00001010，即为正确的结果 10，由此可见，使用补码可以大大地简化计算机对于有符号位的数字的运算过程。